---
name: "\U0001F640 Bug report "
about: Report a bug or unexpected behavior while using the MPU6050 library
title: 'ElectronicCats'
labels: bug
---

**Please, before reporting any issue**
- Make sure your board it's in good condition.
- Make sure your MPU6050 it's in good condition.
- Verify that it really is a library problem and not a hardware problem.
- **Avoid** to submit a GitHub issue for project troubleshooting.

Any feedback/suggestions should be discussed on the [feedback section](https://github.com/ElectronicCats/mpu6050/issues):
  * Just click on New Issue and select the correct category.

When reporting any issue, please try to provide all relevant information to help on its resolution.


**Describe the bug**
A clear and concise description of what the bug is.
The more detailed this is, the easier we can come up with a solution.


**To Reproduce**
Complete source code which can be used to reproduce the issue. Please try to be as generic as possible.
No extra code, extra hardware, etc.
If you think it is absolutely necessary to add this, mention in detail the connections in case it is necessary hardware and also indicate the part of code that was added and how it was added.


**Expected behavior**
A clear and concise description of what you expected to happen.

**Screenshots**
If applicable, add screenshots to help explain your problem.

**To help us to understand your situation, we would like to ask you for the following additional information::**
 - Which board are you using?
 - What Operating System and version are you using (e.g. Windows 11, macOS 12.0, Linux)?
 - In case you are using the Arduino IDE, What version of the Arduino IDE?
 - Did it work before?, If it worked before, what were the parameters that you modify?


**Additional context**
Add any other context about the problem here that you think will help us to solve your problem.